/*
 * PIMPPA: Newsgroup related
 *
 */

#include <fcntl.h>
#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <unistd.h>
#include "proto.h"

#include "../src/pimppa.h"
#include "../src/news.h"

#define LOGWINSIZE_X	640
#define LOGWINSIZE_Y    240

static void leech(GList *list);
// static void leech_selected(GtkWidget *dummy, gpointer data);

static char *groupFlagNames[1]={"Disabled"};

static bowser_flags groupFlags={groupFlagNames, 1};
static bowser_foreign groupForeign={"area_name", "area_id", "p_areas"};

static bowser_column groupDatas[4]=
    {{"g_name", COLUMN_TEXT, 300, "alt.binaries.pictures.goats", NULL},
     {"g_last", COLUMN_NUMBER, 100, "0", NULL},
     {"g_flags", COLUMN_FLAGS, 50, "0", &groupFlags},
     {"g_dest", COLUMN_COMBO, 50, "", &groupForeign}};
static bowser_table groupTable={groupDatas, "p_groups", 4};

GtkWidget *get_groups_box(void)
{
	return(get_table(&groupTable));
}

#if 0	
GtkWidget *get_groups_box(void)
{
	GtkWidget *popupmenu, *tempwid, *group_list;
	GtkWidget *vbox, *hbox, *scrolled_window;
	gchar *grptitles[4]={"Newsgroup", "Destination Area", 
		"Last msg read", "Flags"};

/******** Create main window **********/

	vbox=gtk_vbox_new(FALSE, 0);
	
	group_list=gtk_clist_new_with_titles(4, grptitles);
	gtk_clist_set_selection_mode(GTK_CLIST(group_list), GTK_SELECTION_MULTIPLE);
	gtk_signal_connect(GTK_OBJECT(group_list), "select_row",
						GTK_SIGNAL_FUNC(grp_selected),
						group_list);

/****** Create list window **********/

	scrolled_window = gtk_scrolled_window_new (NULL, NULL);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolled_window),
									GTK_POLICY_AUTOMATIC, GTK_POLICY_ALWAYS);
	gtk_box_pack_start(GTK_BOX(vbox), scrolled_window, TRUE, TRUE, 0);
	gtk_widget_show (scrolled_window);

	gtk_clist_set_shadow_type(GTK_CLIST(group_list), GTK_SHADOW_OUT);

	gtk_clist_set_column_width (GTK_CLIST(group_list), 0, 300);
	gtk_clist_set_column_width (GTK_CLIST(group_list), 1, 120);

	gtk_container_add(GTK_CONTAINER(scrolled_window), group_list);
    gtk_widget_show(group_list);

/******* Add groups popup menu **********/

	popupmenu=gnome_popup_menu_new(groupMenu);
	gnome_popup_menu_attach(popupmenu, group_list, group_list);
	gnome_app_install_menu_hints(GNOME_APP(Bowser), groupMenu);

	refresh_groups(group_list);

	hbox = gtk_hbox_new (TRUE, 15);
	gtk_box_pack_start (GTK_BOX (vbox), hbox, FALSE, FALSE, 0);
	gtk_widget_show (hbox);
	  
	tempwid = gtk_button_new_with_label (_("Add"));
	GTK_WIDGET_SET_FLAGS (tempwid, GTK_CAN_DEFAULT);
	gtk_box_pack_start (GTK_BOX (hbox), tempwid, TRUE, TRUE, 0);
	gtk_signal_connect (GTK_OBJECT (tempwid), "clicked",
						GTK_SIGNAL_FUNC (add_group_stub), group_list);
	gtk_widget_show (tempwid);

	tempwid = gtk_button_new_with_label (_("Edit"));
	GTK_WIDGET_SET_FLAGS (tempwid, GTK_CAN_DEFAULT);
	gtk_box_pack_start (GTK_BOX (hbox), tempwid, TRUE, TRUE, 0);
	gtk_signal_connect (GTK_OBJECT (tempwid), "clicked",
				      GTK_SIGNAL_FUNC (edit_group_stub), group_list);
	gtk_widget_show (tempwid);

	tempwid = gtk_button_new_with_label (_("Delete"));
	GTK_WIDGET_SET_FLAGS (tempwid, GTK_CAN_DEFAULT);
	gtk_box_pack_start (GTK_BOX (hbox), tempwid, TRUE, TRUE, 0);
	gtk_signal_connect (GTK_OBJECT (tempwid), "clicked",
						GTK_SIGNAL_FUNC (delete_group), group_list);
	gtk_widget_show (tempwid);

	return(vbox);
}
#endif

void leech_all(void)
{
	GList *glist;

	glist=get_sql(&db, "SELECT g_name FROM p_groups
						WHERE NOT (g_flags & %ld)",
						GROUP_DISABLED);
	
	leech(glist);
}

#if 0
static void 
leech_selected(GtkWidget *dummy, gpointer data)
{
	GList *tmp, *glist=NULL;

	tmp=GTK_CLIST(data)->selection;
	
	while(tmp)
	{
		int row=(int)tmp->data;
		gchar *groupname, *flags;
	
		gtk_clist_get_text(GTK_CLIST(data), row, 0, &groupname);
		gtk_clist_get_text(GTK_CLIST(data), row, 3, &flags);
		if(strcmp(flags, "Disabled") != 0)
			glist=g_list_append(glist, groupname);
	
		tmp=tmp->next;
	}

	leech(glist);

	gtk_clist_unselect_all(GTK_CLIST(data));
	refresh_groups(GTK_WIDGET(data));
}
#endif

static void 
leech(GList *list)
{
	char buffer[PATH_MAX];
    char nntpserver[PATH_MAX];
	char stderrfile[PATH_MAX];
	GtkAccelGroup *accel_grp;
	GtkWidget *window;
	GtkWidget *vbox;
    GtkWidget *text, *table;
	GList *tmp;
	FILE *fp;
	int status,fd;
	int groups_passed=0,groups_total=0;
	MYSQL_RES *sql_res;
	MYSQL_ROW sql_row;

	if(!list)
	{
		my_error_dialog("How about selecting something first?");
		return;
	}
	
	nntpserver[0]=0;
	p_query(&db, "SELECT misc_data FROM p_misc
					WHERE misc_key='%s'", P_KEY_NNTPSERVER);
	sql_res=mysql_store_result(&db);
	if(sql_res)
	{
		if((sql_row=mysql_fetch_row(sql_res)))
			strcpy(nntpserver, sql_row[0]);
		mysql_free_result(sql_res);
	}
	if(!nntpserver[0])
		strcpy(nntpserver, P_DEFAULT_NNTPSERVER);

/****************** Get total number of groups **************/

	tmp=list;
	while(tmp)
	{
		groups_total++;
		tmp=tmp->next;
	}

/******** Create leech window **********/
	
	window=gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_widget_set_usize(GTK_WIDGET(window), LOGWINSIZE_X, LOGWINSIZE_Y);

	gtk_window_set_title(GTK_WINDOW(window), "PIMPPA leech log...");
//	gtk_signal_connect(GTK_OBJECT(window),
//						"destroy",
//                      GTK_SIGNAL_FUNC(window_close),
//                      window);
	accel_grp=gtk_accel_group_new();
	gtk_window_add_accel_group(GTK_WINDOW(window),accel_grp);
	
	vbox=gtk_vbox_new(FALSE, 0);
    gtk_container_set_border_width(GTK_CONTAINER(vbox), 1);
    gtk_container_add(GTK_CONTAINER(window), vbox);
    gtk_widget_show(vbox);
	
	table = gtk_table_new (2, 2, FALSE);
    gtk_table_set_row_spacing (GTK_TABLE (table), 0, 2);
    gtk_table_set_col_spacing (GTK_TABLE (table), 0, 2);
	gtk_box_pack_start (GTK_BOX(vbox), table, TRUE, TRUE, 0);
    gtk_widget_show (table);

	text=gtk_text_new (NULL, NULL);
  	gtk_table_attach (GTK_TABLE (table), text, 0, 1, 0, 1,
                         GTK_EXPAND | GTK_SHRINK | GTK_FILL,
                         GTK_EXPAND | GTK_SHRINK | GTK_FILL, 0, 0);
    gtk_widget_show (text);
	gtk_widget_realize (text);
	gtk_widget_show(window);

	sprintf(buffer, "Sucking from %s\n\n", nntpserver);
	gtk_text_insert (GTK_TEXT (text), NULL, &text->style->black, NULL,
                     buffer, -1);

/****************** Get the groups **************************/
	
	sprintf(stderrfile, "/tmp/bowser_leech%d.stderr", getpid());

	tmp=list;
	
	while(tmp)
	{
		gchar *groupname=tmp->data;
	
		sprintf(buffer, "Leeching (%3d/%3d): %s", 
				groups_passed+1, groups_total, groupname);
		gnome_appbar_set_status(GNOME_APPBAR(statusBar), buffer);
		gnome_appbar_set_progress(GNOME_APPBAR(statusBar), 
			(float)((float)groups_passed/(float)(groups_total)));
			
		strcat(buffer, "\n");
		gtk_text_insert (GTK_TEXT (text), NULL, &text->style->black, NULL,
   	 	       	         buffer, -1);
		
		while(gtk_events_pending())
			gtk_main_iteration();
		
		unlink(stderrfile);
		mkfifo(stderrfile, 0600);

		if(fork()==0)
		{
			int options, waita, waits;

			freopen(stderrfile, "w", stdout);
			freopen(stderrfile, "w", stderr);

//			printf("Child entering...\n");

			fprintf(stderr, "%s : %s\n", nntpserver, groupname);
		
			options=OPT_VERBOSE; waita=20; waits=2;

			p_dlnews(nntpserver, groupname, options, waita, waits);
//			p_dlnews("moloch.xyz", groupname, 0,20,2);
	
//			printf("Child exiting...\n");
			_exit(0);
		}
		
//		fprintf(stderr, "Parent enters wait...\n");
		
		fd=open(stderrfile, O_RDONLY|O_NONBLOCK);
		fp=fdopen(fd, "r");
		
		while((status=fgetc(fp))==EOF)			// Hackky kludgky kludgee
			usleep(500);

		ungetc(status, fp);

		while(!feof(fp))
		{
//			fprintf(stderr, "Loop\n");
			while(fgets(buffer, 1024, fp)>0)
			{
				gtk_text_insert (GTK_TEXT (text), NULL, &text->style->black, NULL,
   		 	       		         buffer, -1);
			}
		
			if(gtk_events_pending())
				gtk_main_iteration();
			else
				usleep(500);
		}
		
//		fprintf(stderr, "Gone\n");
		
		fclose(fp);
		close(fd);
	
		groups_passed++;
		tmp=tmp->next;
	}

	unlink(stderrfile);
	
	gtk_text_insert (GTK_TEXT (text), NULL, &text->style->black, NULL,
       	             "\nDone. Please destroy this window.\n", -1);
	
	gnome_appbar_set_status(GNOME_APPBAR(statusBar), "");
	gnome_appbar_set_progress(GNOME_APPBAR(statusBar), (float)0);
	
	return;
}

